from sympy import *
from mplot2d import *

k=1000.0
N, m = symbols("N m",real=True,positive=True)
mm=m/k
lb, ft, inch, kn, kg = symbols("lb ft inch kn kg",real=True,positive=True)
measures=[(N,1),(m,1),(lb,1),(ft,1),(inch,1),(kn,1),(kg,1)]

def note(str):
    values = {}
    s=str.split("\n")
    for line in s:
        nv=line.strip().split("=")
        if len(nv) == 2:
            (name,value)=nv
            name = name.strip()
            value = value.strip()
            b=Symbol(name,real=True,positive=True)
            __builtins__[name]=b
            if not (value == ''):
                values[b]=eval(value)
    __builtins__['values']=values

def beamcomponents(l,x):
 """
 list is in form [force,interval,force,interval,...]
 this computes the shear function as one piecewise function
 to make it integrateable with current (broken) sympy code
 see http://code.google.com/p/sympy/issues/detail?id=1695
 and http://code.google.com/p/sympy/issues/detail?id=1646
 """
 state="force"
 len = 0;
 force = 0;
 forcenow = 0
 pieces = [(0,x<0)]
 for i in l:
  i=sympify(i)
  if state == "force":
   force = i.subs(x,x-len)
   state = "interval"
  elif state == "interval":
   pieces.append([forcenow+force,Interval(len,len+i,False,True).contains(x)])
   forcenow=forcenow+force.subs(x,len+i)
   len = len + i
   state = "force"
 if state == "interval":
  ap=[forcenow+force,((len<=x) & (x<oo))]
  pieces.append(ap)
  #print pieces
 return Piecewise(*pieces)

